// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlEntryBox")]
    pub struct EntryBox(Object<ffi::DzlEntryBox, ffi::DzlEntryBoxClass>) @extends gtk::Box, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Orientable;

    match fn {
        type_ => || ffi::dzl_entry_box_get_type(),
    }
}

impl EntryBox {
    #[doc(alias = "dzl_entry_box_new")]
    pub fn new() -> EntryBox {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_entry_box_new()).unsafe_cast() }
    }

    #[doc(alias = "max-width-chars")]
    pub fn max_width_chars(&self) -> i32 {
        ObjectExt::property(self, "max-width-chars")
    }

    #[doc(alias = "max-width-chars")]
    pub fn set_max_width_chars(&self, max_width_chars: i32) {
        ObjectExt::set_property(self, "max-width-chars", max_width_chars)
    }

    #[doc(alias = "max-width-chars")]
    pub fn connect_max_width_chars_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_max_width_chars_trampoline<F: Fn(&EntryBox) + 'static>(
            this: *mut ffi::DzlEntryBox,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::max-width-chars\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_max_width_chars_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for EntryBox {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for EntryBox {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("EntryBox")
    }
}
